/**************************************************************

instmag.c (C-Munipack project)
Table of stars
Copyright (C) 2003 David Motl, dmotl@volny.cz

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>

#include "comfun.h"
#include "cmpack_common.h"
#include "cmpack_phtfile.h"
#include "cmpack_table.h"
#include "trklist.h"
#include "lister.h"

/* Initialize variables */
int list_trk_init(CmpackLister *lc)
{
    /* JD */
	cmpack_tab_set_type(lc->tab, CMPACK_TABLE_TRACKLIST);
	cmpack_tab_add_column(lc->tab, "JD", CMPACK_COLUMN_DOUBLE, JD_PRECISION);
	cmpack_tab_add_column(lc->tab, "OFFSETX", CMPACK_COLUMN_DOUBLE, POS_PRECISION);
	cmpack_tab_add_column(lc->tab, "OFFSETY", CMPACK_COLUMN_DOUBLE, POS_PRECISION);
	return 0;
}

/* Process single file */
int list_trk(CmpackLister *lc, CmpackPhtFile *pht, int frame)
{
	int row;
	double jd, offsetx, offsety;

	/* Read header information */
	jd = cmpack_pht_get_jd(pht);
	if (jd<=0)
		return CMPACK_ERR_READ_ERROR;

	/* Read offsets */
	if (cmpack_pht_get_offset(pht, &offsetx, &offsety)) {
		row = cmpack_tab_add_row(lc->tab);
		cmpack_tab_ptdd(lc->tab, row, 0, jd);
		cmpack_tab_ptdd(lc->tab, row, 1, offsetx);
		cmpack_tab_ptdd(lc->tab, row, 2, offsety);
	}
	return 0;
}

/* Finish reading */
int list_trk_close(CmpackLister *lc)
{
	return 0;
}
