/**************************************************************

helcor_dlg.h (C-Munipack project)
Heliocentric correction dialog
Copyright (C) 2008 David Motl, dmotl@volny.cz

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**************************************************************/

#ifndef CMPACK_HELCOR_DLG_H
#define CMPACK_HELCOR_DLG_H

#include <gtk/gtk.h>

class CHelCorDlg
{
public:
	CHelCorDlg(GtkWindow *pParent);
	~CHelCorDlg();

	void Execute();
private:
	enum tMode
	{
		MODE_HCORR,
		MODE_HJD,
		MODE_GJD
	};

	tMode			m_ActMode;
	GtkWidget		*m_pDlg, *m_Mode, *m_Update;
	GtkWidget		*m_Label1, *m_RA, *m_Dec, *m_JD;
	GtkWidget		*m_Label2, *m_Edit2;

	static bool		ms_ValidRA, ms_ValidDec, ms_ValidJD, ms_NoInput;
	static double	ms_LastJD, ms_LastRA, ms_LastDec;

	static void response_dialog(GtkDialog *pDlg, gint response_id, CHelCorDlg *pMe);
	static void select_changed(GtkComboBox *widget, CHelCorDlg *pMe);
	static void button_clicked(GtkWidget *widget, CHelCorDlg *pMe);

	void SetMode(tMode mode);
	void GetData(void);
	void SetData(void);
};

#endif
